;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; SMW Princess Peach (sprite 7C), by imamelia
;;
;; This is a disassembly of sprite 7C in SMW, Princess Peach as she appears after
;; you defeat Bowser.
;;
;; Uses first extra bit: NO
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; defines and tables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BlushYDisp:
db $01,$11

BlushTiles:
db $6E,$88

PeachTileXDisp:
db $00,$08,$00,$08,$00,$08,$00,$08
db $00,$08,$00,$08,$00,$08,$00,$08
db $00,$08,$00,$08,$00,$08,$00,$08
db $00,$08,$00,$08,$00,$08,$00,$08
db $00,$08,$00,$08,$00,$08,$00,$08
db $00,$08,$00,$08,$00,$08,$00,$08
db $08,$00,$08,$00,$08,$00,$08,$00
db $08,$00,$08,$00,$08,$00,$08,$00
db $08,$00,$08,$00,$08,$00,$08,$00
db $08,$00,$08,$00,$08,$00,$08,$00

PeachTileYDisp:
db $00,$00,$08,$08,$00,$00,$08,$08
db $00,$00,$08,$08,$00,$00,$08,$08
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10
db $00,$00,$10,$10,$00,$00,$10,$10

PeachTilemap:
db $05,$06,$15,$16,$9D,$9E,$4E,$AE
db $06,$05,$16,$15,$9E,$9D,$AE,$4E
db $8A,$8B,$AA,$68,$83,$84,$AA,$68
db $8A,$8B,$80,$81,$83,$84,$80,$81
db $85,$86,$A5,$A6,$83,$84,$A5,$A6
db $82,$83,$A2,$A3,$82,$83,$A2,$A3
db $8A,$8B,$AA,$68,$83,$84,$AA,$68
db $8A,$8B,$80,$81,$83,$84,$80,$81
db $85,$86,$A5,$A6,$83,$84,$A5,$A6
db $82,$83,$A2,$A3,$82,$83,$A2,$A3

PeachTileProps:
db $01,$01,$01,$01,$01,$01,$01,$01
db $41,$41,$41,$41,$41,$41,$41,$41
db $01,$01,$01,$01,$01,$01,$01,$01
db $01,$01,$01,$01,$01,$01,$01,$01
db $00,$00,$00,$00,$01,$01,$00,$00
db $00,$00,$00,$00,$00,$00,$00,$00
db $41,$41,$41,$41,$41,$41,$41,$41
db $41,$41,$41,$41,$41,$41,$41,$41
db $40,$40,$40,$40,$41,$41,$40,$40
db $40,$40,$40,$40,$40,$40,$40,$40

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc

RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR PrincessPeachMain
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PrincessPeachMain:	; $03AC97

LDA $E4,x			;
SEC				;
SBC $1A			;
STA $00			; store Peach's X position relative to the screen to $00
LDA $D8,x			;
SEC				;
SBC $1C			;
STA $01			; store Peach's Y position relative to the screen to $01

LDA $13			;
AND #$7F			;
BNE .NoDisableInteract	;
JSL $01ACF9		;
AND #$07			;
BNE .NoDisableInteract	;
LDA #$0C			;
STA $154C,x		;

.NoDisableInteract		;
LDY $1602,x		;
LDA $154C,x		;
BEQ $01			;
INY				;
LDA $157C,x		;
BNE .FacingLeft		;
TYA				;
CLC				;
ADC #$08			;
TAY				;
.FacingLeft			;
STY $03			; determine which group of 4 tiles Peach will use

LDA #$D0			;
STA $15EA,x		; set her OAM index
TAY				;
JSR PrincessPeachGFX	;
LDY #$02			; 16x16 tiles
LDA #$03			;
JSL $01B7B3			;

LDA $1558,x		;
BEQ .NoBlush		; if the tiles for Mario blushing are supposed to be drawn...

PHX				;
LDX #$00			;
LDA $19			;
BNE $01			;
INX				;
LDY #$4C			; OAM index of the blush tiles
LDA $7E			;
STA $0300,y		;
LDA $80			;
CLC				;
ADC BlushYDisp,x	;
STA $0301,y		;
LDA.w BlushTiles,x	;
STA $0302,y		;
PLX				;
LDA $76			;
CMP #$01			; if the player is facing left...
LDA #$31			;
BCC .StoreBlushProp	;
ORA #$40			; X-flip the blush tiles
.StoreBlushProp		;
STA $0303,y		;
TYA				;
LSR #2			;
TAY				;
LDA #$02			;
STA $0460,y		;

.NoBlush			;

STZ $B6,x			; no X speed for Peach
STZ $7B			; no X speed for the player

LDA #$04			;
STA $1602,x		; frame = 04?

LDA $C2,x			; sprite state
JSL $0086DF		; execute 16-bit pointer

dw S00_Falling		; state 00 - falling through the air
dw S01_StopAfterFall	; state 01 - stationary after the fall
dw S02_WalkForward	; state 02 - walking toward Mario
dw S03_StopAfterWalk	; state 03 - next to Mario
dw S04_Kiss		; state 04 - kissing Mario (and slightly after that)
dw S05_Message		; state 05 - displaying the "Mario's adventure is over..." message
dw S06_BeforeFireworks	; state 06 - between the message and the fireworks
dw S07_Fireworks		; state 07 - fireworks sequence

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 00 - drifting down from Bowser's helicopter
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S00_Falling:

LDA #$06		;
STA $1602,x	; set her frame

JSL $01801A	; update sprite Y position without gravity

LDA $AA,x		;
CMP #$08		;
BCS .NoAccel	; unless her Y speed is already 08...
;CLC			;
;ADC #$01		; increment it
;STA $AA,x		;
INC $AA,x		; (why not just use this instead, Nintendo?)
.NoAccel		;
LDA $14D4,x	;
BMI .S00Finish	; skip the next part if her Y position high byte is negative
LDA $D8,x		;
CMP #$A0		; once Peach gets to Y position A0...
BCC .S00Finish	;
LDA #$A0		;
STA $D8,x		; keep her at Y position A0
STZ $AA,x		; zero out her Y speed
LDA #$A0		;
STA $1540,x	; set the timer for the next sprite state
INC $C2,x		; and change the sprite state to 01

.S00Finish

LDA $13		;
AND #$07		; every 8 frames...
BNE .Return		;
LDY #$0B		;
.Loop			;
LDA $17F0,y	;
BEQ PeachSparkle	; make her sparkle
DEY			;
BPL .Loop		;
.Return		;
RTS			;

PeachSparkle:	; eat your heart out, Edward Cullen

LDA #$05		;
STA $17F0,y	; minor extended sprite 05 - sparkly thingie

JSL $01ACF9	; get a random number (sort of)
STZ $00		;
AND #$1F		;
CLC			;
ADC #$F8		; offset
BPL $02		;
DEC $00		; if the resulting offset was negative, the high byte is FF
CLC			;
ADC $E4,x		;
STA $1808,y	; set the X position of the sparkle
LDA $14E0,x	;
ADC $00		;
STA $18EA,y	;

LDA $148E		;
AND #$1F		;
ADC $D8,x		;
STA $17FC,y	; set the Y position
LDA $14D4,x	;
ADC #$00		;
STA $1814,y	;

LDA #$00		;
STA $1820,y	; Y speed
LDA #$17		;
STA $1850,y	; time to show the sprite
RTS			;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 01 - stationary after falling
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S01_StopAfterFall:

LDA $1540,x		; if it's not time to change sprite state yet...
BNE .NoStateChange	; skip this part

INC $C2,x			; if it is time, change the sprite state to 02 (walking toward the player)

JSR CheckForContact	; check if Peach is in contact with the player
BCC .NoStateChange	; if so...

INC $151C,x		; trigger the kiss? (I think...)

.NoStateChange		;
JSR SubHorizPos		;
TYA				;
STA $157C,x		; the sprite faces the player
STA $76			; and the player faces the opposite direction
RTS				;

CheckForContact:		;

JSL $03B69F			; get sprite clipping A
JSL $03B664			; get player clipping
JSL $03B72B			; check for contact
RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 02 - walking toward the player
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S02_WalkForward:

LDA $14			;
AND #$08			; every 8 frames...
BNE .NoSetFrame		;
LDA #$08			;
STA $1602,x		; set her frame number to 8
.NoSetFrame		;

JSR CheckForContact	; check if the sprite is touching the player
PHP				; preserve the result of this (since it uses the carry flag to tell whether or not contact was made)
JSR SubHorizPos		;
PLP				;

LDA $151C,x		; if the Princess was already touching the player...
BNE .KissBefore		; run a slightly different code
BCS .KissNow		; if the Princess is now touching the player, branch
BRA .SetXSpeed		; if the Princess isn't touching the player, just run the speed routine

.KissBefore			;
BCC .KissNow		; if the Princess is no longer touching the player, branch (what??)
TYA				;
EOR #$01			; invert the direction from SubHorizPos, get it into Y
TAY				;          

.SetXSpeed			;
LDA S02_XSpeed,y		;
STA $B6,x			; set the sprite X speed
EOR #$FF			;
INC				; set the inverse of this...
STA $7B			; to the player's X speed
TYA				;
STA $157C,x		; set the sprite direction
STA $76			; set the player direction
JSL $018022		; update sprite X position without gravity
RTS				;

.KissNow			;
JSR SubHorizPos		;
TYA				;
STA $157C,x		; make the sprite face the player
STA $76			; and the player face the sprite

INC $C2,x			; change the sprite state to 03
LDA #$60			;
STA $1540,x		; set the time before the next state change
RTS				;

S02_XSpeed:
db $08,$F8,$F8,$08

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 03 - next to the player
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S03_StopAfterWalk:

LDA $1540,x		; return if it's not time to change state yet
BNE .Return			;

INC $C2,x			; sprite state = 04
LDA #$A0			; set the time till change
STA $1540,x		;

.Return			;
RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 04 - kissing the player
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S04_Kiss:

LDA $1540,x		; if it isn't time to change state yet...
BNE .NoChangeState	; skip this part
INC $C2,x			; if it is time, change the sprite state to 05
STZ $188A			; clear...unused RAM?
STZ $188B			; not sure why this is here either
.NoChangeState		;
CMP #$50			; if the timer is less than 50, skip the rest
BCC .Return			;

PHA				;
BNE .NoDisable		; if the timer is up...
LDA #$14			;
STA $154C,x		; disable interaction for a bit
.NoDisable			;
LDA #$0A			;
STA $1602,x		; set the frame number to 0A
PLA				;
CMP #$68			; if the timer has reached 68...
BNE .Return			;
LDA #$80			; then set the timer for Mario's blushing
STA $1558,x		;

.Return			;
RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 05 - displaying the "Mario's adventure is over..." message
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S05_Message:

JSR DisplayMessageTiles`	; show the text

LDA $1540,x			; if it's not time to show the next letter...
BNE .Return				; return

LDY $1921				;
CPY #$54				; if 0x53 tiles have been drawn...
BEQ .ChangeState			; then move on to the next sprite state

INC $1921				; if not, increment the message tile counter
LDA TimeBetweenLetters,y	; set the time until the next letter should be shown
STA $1540,x			;

.Return				;
RTS					;

.ChangeState			;
INC $C2,x				; sprite state = 06
LDA #$40				;
STA $1540,x			; time until the next change
RTS					;

DisplayMessageTiles:

PHX					; preserve the sprite index
REP #$30				; set 16-bit AXY
LDX $1921				; if the tile counter is still at 0...
BEQ .EndMessage			; skip the message
DEX					;
LDY.w #$0000			; start at OAM index 0

.Loop					;

PHX					; preserve the tile index
TXA					;
ASL #2				; multiply it by 4
TAX					;
LDA.w MessageData,x		; because there are 4 bytes per tile
STA $0200,y			; set the X and Y position of the tile
LDA.w MessageData+2,x	;
STA $0202,y			; set the tile number and tile properties of the tile

PHY					;
TYA					;
LSR #2				; divide the OAM index by 4
TAY					;
SEP #$20				;
LDA #$00				; in order to set
STA $0420,y			; the tile size
REP #$20				;
PLY					;
PLX					;

INY #4				; next OAM slot
DEX					; if there are more tiles to draw...
BPL .Loop				; go back to the beginning of the loop

.EndMessage			;
SEP #$30				; set 8-bit AXY
PLX					; restore the sprite index
RTS					;

; timer for how long it takes the next letter to appear
TimeBetweenLetters:
db $08,$08,$08,$08,$08,$08,$18,$08
db $08,$08,$08,$08,$08,$08,$08,$08
db $08,$08,$08,$08,$08,$08,$20,$08
db $08,$08,$08,$08,$20,$08,$08,$10
db $08,$08,$08,$08,$08,$08,$08,$08
db $20,$08,$08,$08,$08,$08,$20,$08
db $04,$20,$08,$08,$08,$08,$08,$08
db $08,$08,$08,$08,$08,$08,$10,$08
db $08,$08,$08,$08,$08,$08,$08,$08
db $08,$08,$10,$08,$08,$08,$08,$08
db $08,$08,$08,$40

; OAM data for all the tiles in the message
; 4 bytes per tile: X position, Y position, tile number, tile properties
MessageData:
db $18,$20,$A1,$0E,$20,$20,$88,$0E,$28,$20,$AB,$0E,$30,$20,$99,$0E
db $38,$20,$A8,$0E,$40,$20,$BF,$0E,$48,$20,$AC,$0E,$58,$20,$88,$0E
db $60,$20,$8B,$0E,$68,$20,$AF,$0E,$70,$20,$8C,$0E,$78,$20,$9E,$0E
db $80,$20,$AD,$0E,$88,$20,$AE,$0E,$90,$20,$AB,$0E,$98,$20,$8C,$0E
db $A8,$20,$99,$0E,$B0,$20,$AC,$0E,$C0,$20,$A8,$0E,$C8,$20,$AF,$0E
db $D0,$20,$8C,$0E,$D8,$20,$AB,$0E,$E0,$20,$BD,$0E,$18,$30,$A1,$0E
db $20,$30,$88,$0E,$28,$30,$AB,$0E,$30,$30,$99,$0E,$38,$30,$A8,$0E
db $40,$30,$BE,$0E,$48,$30,$AD,$0E,$50,$30,$98,$0E,$58,$30,$8C,$0E
db $68,$30,$A0,$0E,$70,$30,$AB,$0E,$78,$30,$99,$0E,$80,$30,$9E,$0E
db $88,$30,$8A,$0E,$90,$30,$8C,$0E,$98,$30,$AC,$0E,$A0,$30,$AC,$0E
db $A8,$30,$BE,$0E,$B0,$30,$B0,$0E,$B8,$30,$A8,$0E,$C0,$30,$AC,$0E
db $C8,$30,$98,$0E,$D0,$30,$99,$0E,$D8,$30,$BE,$0E,$18,$40,$88,$0E
db $20,$40,$9E,$0E,$28,$40,$8B,$0E,$38,$40,$98,$0E,$40,$40,$99,$0E
db $48,$40,$AC,$0E,$58,$40,$8D,$0E,$60,$40,$AB,$0E,$68,$40,$99,$0E
db $70,$40,$8C,$0E,$78,$40,$9E,$0E,$80,$40,$8B,$0E,$88,$40,$AC,$0E
db $98,$40,$88,$0E,$A0,$40,$AB,$0E,$A8,$40,$8C,$0E,$B8,$40,$8E,$0E
db $C0,$40,$A8,$0E,$C8,$40,$99,$0E,$D0,$40,$9E,$0E,$D8,$40,$8E,$0E
db $18,$50,$AD,$0E,$20,$50,$A8,$0E,$30,$50,$AD,$0E,$38,$50,$88,$0E
db $40,$50,$9B,$0E,$48,$50,$8C,$0E,$58,$50,$88,$0E,$68,$50,$AF,$0E
db $70,$50,$88,$0E,$78,$50,$8A,$0E,$80,$50,$88,$0E,$88,$50,$AD,$0E
db $90,$50,$99,$0E,$98,$50,$A8,$0E,$A0,$50,$9E,$0E,$A8,$50,$BD,$0E

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 06 - before the fireworks scene
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S06_BeforeFireworks:

LDA $1540,x		;
BEQ .ChangeState		; change to state 07 if it's time

LSR				;
STA $00			;
STZ $01			;
REP #$20			;
LDA $00			;
ASL #5			;
ORA $00			;
STA $00			; ...um...what??
ASL #5			;
ORA $00			;
STA $00			; ...
SEP #$20			;

PHX				;
TAX				;
LDY $0681			; something about dynamically changing the palette...
LDA #$02			;
STA $0682,y		;
LDA #$F1			;
STA $0683,y		;
LDA $00			;
STA $0684,y		;
LDA $01			;
STA $0685,y		;
LDA #$00			;
STA $0686,y		; ...I think this code has to do with the fade before the fireworks...
TYA				;
CLC				;
ADC #$04			;
STA $0681			;
PLX				;

JSR DisplayMessageTiles	;
RTS				;

.ChangeState		;
INC $C2,x			; sprite state = 07
LDA #$80			;
STA $1FEB			; it seems to assume that Peach has a certain sprite index here...
RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; sprite state 07 - spawning fireworks
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

S07_Fireworks:

LDA $1564,x		; if the ending timer is not set...
BEQ .FireworkCheck	; check to see if fireworks should be spawned
DEC				; if the timer is almost up...
BNE .Return			;
INC $13C6			; set the cutscene number
LDA #$FF			;
STA $1493			; and make the level end
.Return			;
RTS				;

.FireworkCheck		;
LDA $156D			; again, assuming Peach has a specific sprite index...
AND #$03			;
TAY				;
LDA BGColorLow,y		;
STA $0701			; set the background color depending on the firework timer
LDA BGColorHigh,y	;
STA $0702			;

LDA $1FEB			; if it's not time to spawn the next firework yet...
BNE .Return			; return

LDA $1534,x		;
CMP #$04			; if 4 fireworks have already been spawned...
BEQ .EndFireworks		; set the ending timer

LDY #$01			;
.Loop				;
LDA $14C8,y		; check for a free sprite slot for the firework
BEQ .SpawnFirework	;
DEY				;
BPL .Loop			;
RTS				;

.SpawnFirework		;

LDA #$08			;
STA $14C8,y		; sprite status

LDA #$7A			;
STA $009E,y		; sprite number

LDA #$00			;
STA $14E0,y		; sprite X position high byte
LDA #$A8			;
CLC				;
ADC $1C			;
STA $00D8,y		; sprite Y position low byte
LDA $1D			;
ADC #$00			;
STA $14D4,y		;

PHX				;
TYX				; new sprite index into X
JSL $07F7D2		; initialize the sprite tables
PLX				;

PHX				;
LDA $1534,x		;
AND #$03			; firework counter into...pattern of the firework?
STA $1534,y		;
TAX				;
LDA.w FireworkTimer,x	; set the time until the next firework spawns
STA $1FEB			;
LDA.w FireworkXPosLo,x	; set the X position of the firework
STA $00E4,y		;
PLX				;

INC $1534,x		; increment the firework counter
RTS				;

.EndFireworks		;
LDA #$70			;
STA $1564,x		;
RTS				;

BGColorLow:
db $00,$AA,$FF,$AA

BGColorHigh:
db $00,$7E,$27,$7E

FireworkXPosLo:
db $60,$B0,$40,$80

FireworkTimer:
db $C0,$C0,$FF,$C0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; graphics routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PrincessPeachGFX:		; $03AAC8

LDA $03			; frame number
ASL #2			;
STA $04			;

PHX				;
LDX #$03			; 4 tiles to draw

.Loop

PHX				;
TXA				;
CLC				;
ADC $04			; tile index plus frame index
TAX				;

LDA $00			;
CLC				;
ADC.w PeachTileXDisp,x	;
STA $0300,y		;

LDA $01			;
CLC				;
ADC.w PeachTileYDisp,x	;
STA $0301,y		;

LDA.w PeachTilemap,x	;
STA $0302,y		;

LDA.w PeachTileProps,x	;
PHX				;
LDX $15E9			;
CPX #$09			;
BEQ $02			;
ORA #$30			;
STA $0303,y		;
PLX				;

PHY				;
TYA				;
LSR #2			;
TAY				;
LDA #$02			;
STA $0460,y		;
PLY				;

INY #4			;
PLX				;
DEX				;
BPL .Loop			;

PLX				;
RTS				;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; miscellaneous standard subroutines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Table1:	db $0C,$1C
Table2:	db $01,$02
Table3:	db $40,$B0
Table6:	db $01,$FF
Table4:	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:	db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreenX0:
LDA #$00
;BRA SubOffscreenMain
;SubOffscreenX1:
;LDA #$02
;BRA SubOffscreenMain
;SubOffscreenX2:
;LDA #$04
;BRA SubOffscreenMain
;SubOffscreenX3:
;LDA #$06
;BRA SubOffscreenMain
;SubOffscreenX4:
;LDA #$08
;BRA SubOffscreenMain
;SubOffscreenX5:
;LDA #$0A
;BRA SubOffscreenMain
;SubOffscreenX6:
;LDA #$0C
;BRA SubOffscreenMain
;SubOffscreenX7:
;LDA #$0E

SubOffscreenMain:

STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS

SubHorizPos:

LDY #$00
LDA $94
SEC
SBC $E4,x
STA $0F
LDA $95
SBC $14E0,x
BPL $01
INY
RTS






